SystemOrganization addCategory: #'Magma upgrader-Utilities'!
SystemOrganization addCategory: #'Magma upgrader-old buffers'!
SystemOrganization addCategory: #'Magma upgrader-modified Magma classes'!

!MagmaRepositoryController methodsFor: '*magma upgrader' stamp: 'cmm 8/11/2010 11:00'!
localLocation: aMagmaLocalLocation 
	localLocation := aMagmaLocalLocation! !

MagmaRepositoryController subclass: #MagmaRepositoryController13
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma upgrader-modified Magma classes'!

!MagmaRepositoryController13 methodsFor: 'as yet unclassified' stamp: 'cmm 8/11/2010 23:50'!
initializeSession
	session := MagmaSession13 repositoryController: self.
	session readStrategy: self serverReadStrategy.
	self initializeServerSerializer! !

MaByteObjectBuffer subclass: #MaByteObjectBuffer13
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma upgrader-old buffers'!

!MaByteObjectBuffer13 class methodsFor: 'as yet unclassified' stamp: 'cmm 8/12/2010 14:50'!
bufferPositionOfControlFields
	"Zero-based position of the control-fields (buffer-type and isStorageObject)."

	^ 9! !

!MaByteObjectBuffer13 class methodsFor: 'as yet unclassified' stamp: 'cmm 8/11/2010 10:41'!
sizeOfPhysicalSizeField
	"in bits."
	^ 24! !

!MaByteObjectBuffer13 methodsFor: 'as yet unclassified' stamp: 'cmm 8/12/2010 15:26'!
as14
	| answer myBytes |
	answer := (MaByteObjectBuffer
		byteArray: (ByteArray new: self physicalSize+4)
		startPos: 0)
		 controlFields: self controlFields ;
		 classId: self classId ;
		 oid: self oid ;
		 physicalSize: self physicalSize+4 ;
		 commitNumber: self commitNumber ;
		 type: self type.
	myBytes := self asByteArray.
	answer
		replaceFrom: 1
		to: myBytes size
		with: myBytes
		startingAt: 1.
self assert: answer byteArray size = answer physicalSize.
self assert: answer asByteArray = myBytes.
	^ answer! !

!MaByteObjectBuffer13 methodsFor: 'as yet unclassified' stamp: 'cmm 8/12/2010 14:29'!
bufferPositionOfClassId
	"Zero-based position of the class id."

	^ 10! !

!MaByteObjectBuffer13 methodsFor: 'as yet unclassified' stamp: 'cmm 8/12/2010 14:36'!
bufferPositionOfCommitNumber
	"Bumping over the classVersion for FixedObjectBuffers."
	^ 12! !

!MaByteObjectBuffer13 methodsFor: 'as yet unclassified' stamp: 'cmm 8/10/2010 22:14'!
headerSize
	"The old headerSize in Magma versions 13 and earlier."
	^ 26! !

MagmaSession subclass: #MagmaSession13
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma upgrader-modified Magma classes'!

!MagmaSession13 methodsFor: 'as yet unclassified' stamp: 'cmm 8/12/2010 00:03'!
initializeSerializer
	serializer := MaObjectSerializer13 new
		bpMapIndex: (MaObjectBuffer indexOfBpMap: MagmaBufferPositionMap) ;
		toCreateProxies: 
			[ : oid | 
			MagmaMutatingProxy 
				session: self
				oid: oid ] ;
		classIdManager: MagmaClassIdManager new ;
		oidManager: (MagmaOidManager new
				statistics: self statistics ;
				yourself) ;
		yourself.
	serializer traversalStrategy
		traverseWhen: 
			[ : path : parent : indexInteger | 
			(path last 
				maShouldTraverseWithPath: path
				parent: parent
				index: indexInteger) and: 
				[ path size <= 2 or: 
					[ "Because we're serializing an Array of only changed objects, we only need capture their first level, but don't forget the OC container is level 1."
					MaOidCalculator isOidForNewObject: (self oidFor: path last) ] ] ] ;
		valueWhen: 
			[ : path : parent : index | 
			(path last 
				maShouldAppendWithPath: path
				parent: parent
				index: index) and: 
				[ path size <= 2 or: [ MaOidCalculator isOidForNewObject: (self oidFor: path last) ] ] ].
	serializer preferences
		beforeSerializingAny: #MagmaForwardingProxy
			do: [ : aMagmaForwardingProxy | aMagmaForwardingProxy ensureReferencePopulated ] ;
		beforeSerializingAny: #Morph
			do: 
				[ : aMorph | 
				"(sigh) Morphs keep their own #updateableActionMap, the map used to hold event-listener definitions.  Before, we were setting up these listeners on *materialization*, but this was causing them to be marked dirty immediately.  Therefore, we go ahead and set these listeners up 'permanently' upon serialization."
				aMorph wantsMagmaEvents ifTrue: 
					[ aMorph 
						when: #magmaAboutToRefresh
						send: #aboutToRefreshFromMagma:
						to: aMorph.	"aMagmaRefreshEvent"
					aMorph 
						when: #magmaRefreshed
						send: #refreshedFromMagma:
						to: aMorph	"aMagmaRefreshEvent" ] ] ;
		afterMaterializingAny: #MagmaLargeCollection
			do: 
				[ : aMagmaCollection | 
				aMagmaCollection
					initializeChanges ;
					setOid: (serializer oidFor: aMagmaCollection) ].
	MagmaCollectionReader withAllSubclasses do: 
		[ : each | 
		serializer preferences 
			afterMaterializingAny: each name
			do: 
				[ : aMagmaCollectionReader | 
				aMagmaCollectionReader
					fixUpExpression ;
					setUpListener ;
					refresh ] ]! !

MaStorageObjectBuffer subclass: #MaStorageObjectBuffer13
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma upgrader-old buffers'!

!MaStorageObjectBuffer13 class methodsFor: 'as yet unclassified' stamp: 'cmm 8/12/2010 14:50'!
bufferPositionOfControlFields
	"Zero-based position of the control-fields (buffer-type and isStorageObject)."

	^ 9! !

!MaStorageObjectBuffer13 class methodsFor: 'as yet unclassified' stamp: 'cmm 8/11/2010 18:03'!
sizeOfPhysicalSizeField
	"in bits."
	^ 24! !

!MaStorageObjectBuffer13 methodsFor: 'upgrading' stamp: 'cmm 8/12/2010 15:55'!
as14
	| answer buffers graphBufferSize graphBuffer graphBufferBytes |
	buffers := ByteArray streamContents:
		[ : stream | self buffersDo:
			[ : eachBuffer13 | stream nextPutAll: eachBuffer13 as14 trimmedByteArray ] ].
	graphBufferSize := MaSerializedGraphBuffer headerSize + buffers size.
	graphBuffer := MaSerializedGraphBuffer new: graphBufferSize.
	graphBuffer byteArray
		replaceFrom: MaSerializedGraphBuffer headerSize + 1
		to: graphBuffer byteArray size
		with: buffers
		startingAt: 1.
	graphBuffer bufferSize: graphBufferSize.
	graphBufferBytes := graphBuffer trimmedByteArray.
	answer := (MaStorageObjectBuffer
		byteArray: (ByteArray new: 1000)
		startPos: 0)
		 controlFields: self controlFields ;
		 classId: self classId ;
		 oid: self oid ;
		 commitNumber: self commitNumber ;
		 type: self type ;
		 yourself.
	answer physicalSize: graphBufferBytes size + answer headerSize.
	answer
		ensureSpaceFor: graphBufferBytes
		using: MagmaBufferPositionMap.
	answer
		replaceFrom: 1
		to: graphBufferBytes size
		with: graphBufferBytes
		startingAt: 1.
	^ answer trimByteArray! !

!MaStorageObjectBuffer13 methodsFor: 'overriding' stamp: 'cmm 8/12/2010 14:33'!
bufferPositionOfClassId
	"Zero-based position of the class id."

	^ 10! !

!MaStorageObjectBuffer13 methodsFor: 'overriding' stamp: 'cmm 8/12/2010 14:37'!
bufferPositionOfCommitNumber
	"Bumping over the classVersion for FixedObjectBuffers."
	^ 12! !

!MaStorageObjectBuffer13 methodsFor: 'overriding' stamp: 'cmm 8/12/2010 15:32'!
buffersDo: aBlock

	(MaSerializedGraphBuffer13 byteArray: self asByteArray) buffersDo: aBlock! !

!MaStorageObjectBuffer13 methodsFor: 'overriding' stamp: 'cmm 8/11/2010 10:40'!
headerSize
	"The old headerSize in Magma versions 13 and earlier."
	^ 26! !

MaObjectBuffer subclass: #MaObjectBuffer13
	instanceVariableNames: ''
	classVariableNames: 'BufferClasses13'
	poolDictionaries: ''
	category: 'Magma upgrader-old buffers'!

!MaObjectBuffer13 class methodsFor: 'access' stamp: 'cmm 8/12/2010 14:12'!
bufferClasses
	^ BufferClasses13! !

!MaObjectBuffer13 class methodsFor: 'access' stamp: 'cmm 8/10/2010 21:56'!
bufferPositionOfControlFields
	"Zero-based position of the control-fields (buffer-type and isStorageObject)."

	^ 9! !

!MaObjectBuffer13 class methodsFor: 'initializing' stamp: 'cmm 8/13/2010 16:38'!
initialize
	"Called from preamble of MaObjectSerialization."
	self
		initializeBufferClasses ;
		initializeBufferPositionMaps! !

!MaObjectBuffer13 class methodsFor: 'access' stamp: 'cmm 8/12/2010 14:24'!
initializeBufferClasses
	BufferClasses13 := Array 
		with: MaByteObjectBuffer13
		with: MaVariableObjectBuffer13
		with: MaFixedObjectBuffer13
		with: MaVariableWordBuffer13
		with: MaStorageObjectBuffer13! !

!MaObjectBuffer13 class methodsFor: 'access' stamp: 'cmm 8/10/2010 21:56'!
sizeOfPhysicalSizeField
	"in bits."
	^ 24! !

!MaObjectBuffer13 methodsFor: 'overriding' stamp: 'cmm 8/10/2010 21:54'!
bufferPositionOfClassId
	"Zero-based position of the class id."

	^ 10! !

!MaObjectBuffer13 methodsFor: 'overriding' stamp: 'cmm 8/10/2010 21:55'!
bufferPositionOfCommitNumber
	"Bumping over the classVersion for FixedObjectBuffers."
	^ 12! !

!MaObjectBuffer13 methodsFor: 'overriding' stamp: 'cmm 8/10/2010 22:11'!
headerSize
	"The old headerSize in Magma versions 13 and earlier."
	^ 26! !

MaObjectSerializer subclass: #MaObjectSerializer13
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma upgrader-modified Magma classes'!

!MaObjectSerializer13 methodsFor: 'as yet unclassified' stamp: 'cmm 8/12/2010 00:04'!
initialize
	super initialize.
"Should be ok to initialize this after everything else."
	self graphBuffer: (MaSerializedGraphBuffer13 new: 50)! !

!MaObjectSerializer13 methodsFor: 'as yet unclassified' stamp: 'cmm 8/12/2010 11:28'!
initializePreMadeObjectBuffers

	preMadeObjectBuffers := MaObjectBuffer13 bufferClasses collect:
		[ :each |
		each
			byteArray: self byteArray
			startPos: 0 ]
! !

!MaObjectSerializer13 methodsFor: 'as yet unclassified' stamp: 'cmm 8/12/2010 00:05'!
postCopyWithNewBuffer

	graphBuffer := MaSerializedGraphBuffer13 new: 1000.
	self
		initializePreMadeObjectBuffers;
		resetByteArray;
		beBored! !

!MaObjectFiler methodsFor: '*magma upgrader' stamp: 'cmm 8/11/2010 11:21'!
preMadeObjectBuffer: aMaObjectBuffer13
	preMadeObjectBuffer := aMaObjectBuffer13! !

MaSerializedGraphBuffer subclass: #MaSerializedGraphBuffer13
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma upgrader-modified Magma classes'!

!MaSerializedGraphBuffer13 methodsFor: 'as yet unclassified' stamp: 'cmm 8/12/2010 11:29'!
bufferPositionsDo: oneArgBlock 
	"Value oneArgBlock with the value of the starting position of each
	buffer in the receiver."
	| pos end |
	pos := self headerSize.
	end := self bufferSize - 1.
	[ pos <= end ] whileTrue:
		[ | physicalSize bufferClass |
		oneArgBlock value: pos.
		bufferClass := MaObjectBuffer13
			bufferClassFor: byteArray
			startPos: pos.
		physicalSize := byteArray
			maUint: bufferClass sizeOfPhysicalSizeField
			at: pos + bufferClass bufferPositionOfPhysicalSize.
		pos := pos + physicalSize ]! !

!MaSerializedGraphBuffer13 methodsFor: 'as yet unclassified' stamp: 'cmm 8/12/2010 11:27'!
bufferTypeAt: startPositionOfObjectBuffer

	^ MaObjectBuffer13
		bufferTypeIn: byteArray
		startingAt: startPositionOfObjectBuffer! !

!MaSerializedGraphBuffer13 methodsFor: 'as yet unclassified' stamp: 'cmm 8/11/2010 23:46'!
newPremadeBuffers

	^MaObjectBuffer13 bufferClasses collect: [ :each | each new ]
! !

MaVariableWordBuffer subclass: #MaVariableWordBuffer13
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma upgrader-old buffers'!

!MaVariableWordBuffer13 class methodsFor: 'as yet unclassified' stamp: 'cmm 8/12/2010 14:50'!
bufferPositionOfControlFields
	"Zero-based position of the control-fields (buffer-type and isStorageObject)."

	^ 9! !

!MaVariableWordBuffer13 class methodsFor: 'as yet unclassified' stamp: 'cmm 8/11/2010 18:03'!
sizeOfPhysicalSizeField
	"in bits."
	^ 24! !

!MaVariableWordBuffer13 methodsFor: 'upgrading' stamp: 'cmm 8/12/2010 15:29'!
as14
	| answer |
self halt.
	answer := (MaVariableWordBuffer
		byteArray: (ByteArray new: self physicalSize+4)
		startPos: 0)
		 controlFields: self controlFields ;
		 classId: self classId ;
		 oid: self oid ;
		 physicalSize: self physicalSize+4 ;
		commitNumber: self commitNumber ;
		 type: self type.
	self instVarsDoWithIndex:
		[ : eachOid : x | answer
			maInstVarAt: x
			put: eachOid ].
self assert: answer byteArray size = answer physicalSize.
	^ answer! !

!MaVariableWordBuffer13 methodsFor: 'overriding' stamp: 'cmm 8/12/2010 14:33'!
bufferPositionOfClassId
	"Zero-based position of the class id."

	^ 10! !

!MaVariableWordBuffer13 methodsFor: 'overriding' stamp: 'cmm 8/12/2010 14:37'!
bufferPositionOfCommitNumber
	"Bumping over the classVersion for FixedObjectBuffers."
	^ 12! !

!MaVariableWordBuffer13 methodsFor: 'overriding' stamp: 'cmm 8/10/2010 22:13'!
headerSize
	"The old headerSize in Magma versions 13 and earlier."
	^ 26! !

MaVariableObjectBuffer subclass: #MaVariableObjectBuffer13
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma upgrader-old buffers'!

!MaVariableObjectBuffer13 class methodsFor: 'as yet unclassified' stamp: 'cmm 8/12/2010 14:50'!
bufferPositionOfControlFields
	"Zero-based position of the control-fields (buffer-type and isStorageObject)."

	^ 9! !

!MaVariableObjectBuffer13 class methodsFor: 'as yet unclassified' stamp: 'cmm 8/11/2010 18:02'!
sizeOfPhysicalSizeField
	"in bits."
	^ 24! !

!MaVariableObjectBuffer13 methodsFor: 'upgrading' stamp: 'cmm 8/12/2010 15:30'!
as14
	| answer |
	answer := (MaVariableObjectBuffer
		byteArray: (ByteArray new: self physicalSize+4) "because we expanded by 4 bytes"
		startPos: 0) 
		controlFields: self controlFields ;
		classId: self classId ;
		oid: self oid ;
		physicalSize: self physicalSize+4 ;
		commitNumber: self commitNumber ;
		type: self type.
	self instVarsDoWithIndex:
		[ : eachOid : x | answer
			maInstVarAt: x
			put: eachOid ].
self assert: answer byteArray size = answer physicalSize.
	^ answer! !

!MaVariableObjectBuffer13 methodsFor: 'overriding' stamp: 'cmm 8/12/2010 14:33'!
bufferPositionOfClassId
	"Zero-based position of the class id."

	^ 10! !

!MaVariableObjectBuffer13 methodsFor: 'overriding' stamp: 'cmm 8/12/2010 14:37'!
bufferPositionOfCommitNumber
	"Bumping over the classVersion for FixedObjectBuffers."
	^ 12! !

!MaVariableObjectBuffer13 methodsFor: 'overriding' stamp: 'cmm 8/11/2010 10:36'!
headerSize
	"The old headerSize in Magma versions 13 and earlier."
	^ 26! !

MagmaCompressor subclass: #MagmaUpgrader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma upgrader-Utilities'!

!MagmaUpgrader methodsFor: 'overriding' stamp: 'cmm 8/12/2010 14:38'!
openInput
	inputController := MagmaRepositoryController13 new
		 localLocation: sourceLocation ;
		 initializeSession ;
		 yourself.
	inputController repository:
		([ MaObjectRepository
			open: sourceLocation directory
			controller: inputController ]
			on: MagmaWarning
			do:
				[ : err | err resume ]).
	"Repository files are open, now set up the Filer before trying to read any buffers."
	inputController repository filer preMadeObjectBuffer: MaObjectBuffer13 new.
	inputController postOpenInitialize! !

!MagmaUpgrader methodsFor: 'overriding' stamp: 'cmm 8/12/2010 22:29'!
postCompress
	super postCompress.
	outputFiler version: MagmaSession magmaVersion! !

!MagmaUpgrader methodsFor: 'overriding' stamp: 'cmm 8/11/2010 11:33'!
upgrade: aMaObjectBuffer13
	^ aMaObjectBuffer13 as14! !

MaFixedObjectBuffer subclass: #MaFixedObjectBuffer13
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma upgrader-old buffers'!

!MaFixedObjectBuffer13 class methodsFor: 'as yet unclassified' stamp: 'cmm 8/12/2010 14:50'!
bufferPositionOfControlFields
	"Zero-based position of the control-fields (buffer-type and isStorageObject)."

	^ 9! !

!MaFixedObjectBuffer13 class methodsFor: 'as yet unclassified' stamp: 'cmm 8/11/2010 10:41'!
sizeOfPhysicalSizeField
	"in bits."
	^ 24! !

!MaFixedObjectBuffer13 methodsFor: 'upgrading' stamp: 'cmm 8/12/2010 15:27'!
as14
	| answer |
	answer := (MaFixedObjectBuffer
		byteArray: (ByteArray new: self physicalSize+4) "because we expanded by 4 bytes"
		startPos: 0) 
		controlFields: self controlFields ;
		classVersion: self classVersion ;
		classId: self classId ;
		oid: self oid ;
		physicalSize: self physicalSize+4 ;
		commitNumber: self commitNumber ;
		type: self type.
	self instVarsDoWithIndex:
		[ : eachOid : x | answer
			maInstVarAt: x
			put: eachOid ].
self assert: answer byteArray size = answer physicalSize.
	^ answer! !

!MaFixedObjectBuffer13 methodsFor: 'overriding' stamp: 'cmm 8/12/2010 14:32'!
bufferPositionOfClassId
	"Zero-based position of the class id."

	^ 10! !

!MaFixedObjectBuffer13 methodsFor: 'overriding' stamp: 'cmm 8/12/2010 15:02'!
bufferPositionOfClassVersion
	"Magma adds 12 additional bytes."
	^ 24! !

!MaFixedObjectBuffer13 methodsFor: 'overriding' stamp: 'cmm 8/12/2010 14:36'!
bufferPositionOfCommitNumber
	"Bumping over the classVersion for FixedObjectBuffers."
	^ 12! !

!MaFixedObjectBuffer13 methodsFor: 'overriding' stamp: 'cmm 8/10/2010 22:11'!
headerSize
	"The old headerSize in Magma versions 13 and earlier."
	^ 26! !
MaObjectBuffer13 initialize!
